// DocEngineInterface.cpp : implementation file
//

#include "stdafx.h"
#include "ComSample.h"
#include "SomethingComplicated.h"
#include "DocEngineInterface.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDocEngineInterface

IMPLEMENT_DYNCREATE(CDocEngineInterface, CCmdTarget)

CDocEngineInterface::CDocEngineInterface() {
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	
	AfxOleLockApp();
}

CDocEngineInterface::~CDocEngineInterface() {
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	
	AfxOleUnlockApp();
}

void CDocEngineInterface::OnFinalRelease() {
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CDocEngineInterface, CCmdTarget)
	//{{AFX_MSG_MAP(CDocEngineInterface)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CDocEngineInterface, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CDocEngineInterface)
	DISP_FUNCTION(CDocEngineInterface, "HelloWorld", HelloWorld, VT_VARIANT, VTS_NONE)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IDocEngineInterface to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {27A79D72-7D69-11D2-9378-444553540000}
static const IID IID_IDocEngineInterface =
{ 0x27a79d72, 0x7d69, 0x11d2, { 0x93, 0x78, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0 } };

BEGIN_INTERFACE_MAP(CDocEngineInterface, CCmdTarget)
	INTERFACE_PART(CDocEngineInterface, IID_IDocEngineInterface, Dispatch)
END_INTERFACE_MAP()

// {27A79D73-7D69-11D2-9378-444553540000}
IMPLEMENT_OLECREATE(CDocEngineInterface, "ComSample.DocEngineInterface", 0x27a79d73, 0x7d69, 0x11d2, 0x93, 0x78, 0x44, 0x45, 0x53, 0x54, 0x0, 0x0)

/////////////////////////////////////////////////////////////////////////////
// CDocEngineInterface message handlers

VARIANT CDocEngineInterface::HelloWorld() {
	COleVariant vaResult = CString("");
	CSomethingComplicated complicated;
	CString sHelloWord("");

	sHelloWord = complicated.HelloWorld();
	vaResult = sHelloWord;

	return vaResult;
}